<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CommentsInserter xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/javaparser/CommentsInserter.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment">  */</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_comment"> * Copyright (C) 2007-2010 Júlio Vilmar Gesser.</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_comment"> * Copyright (C) 2011, 2013-2015 The JavaParser Team.</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_comment"> * This file is part of JavaParser.</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_comment"> * </em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <em class="jxr_comment"> * JavaParser can be used either under the terms of</em>
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <em class="jxr_comment"> * a) the GNU Lesser General Public License as published by</em>
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <em class="jxr_comment"> *     the Free Software Foundation, either version 3 of the License, or</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_comment"> *     (at your option) any later version.</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_comment"> * b) the terms of the Apache License </em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_comment"> * You should have received a copy of both licenses in LICENCE.LGPL and</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_comment"> * LICENCE.APACHE. Please refer to those files for details.</em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_comment"> * JavaParser is distributed in the hope that it will be useful,</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <em class="jxr_comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</em>
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <em class="jxr_comment"> * GNU Lesser General Public License for more details.</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> java.util.Collections;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> java.util.LinkedList;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.CompilationUnit;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.Node;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.comments.Comment;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.comments.CommentsCollection;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.comments.CommentsParser;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.comments.LineComment;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment"> * @author Sebastian Kuerten</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment"> * @author Júlio Vilmar Gesser</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/CommentsInserter.html">CommentsInserter</a>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> doNotAssignCommentsPreceedingEmptyLines = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> doNotConsiderAnnotationsAsNodeStartForCodeAttribution = false;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> insertComments(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/CompilationUnit.html">CompilationUnit</a> cu, String code)
<a class="jxr_linenumber" name="L55" href="#L55">55</a>              <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>          <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/CommentsParser.html">CommentsParser</a> commentsParser = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/CommentsParser.html">CommentsParser</a>();
<a class="jxr_linenumber" name="L57" href="#L57">57</a>          <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/CommentsCollection.html">CommentsCollection</a> allComments = commentsParser.parse(code);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>          insertCommentsInCu(cu, allComments);
<a class="jxr_linenumber" name="L60" href="#L60">60</a>      }
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  
<a class="jxr_linenumber" name="L62" href="#L62">62</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> getDoNotConsiderAnnotationsAsNodeStartForCodeAttribution() {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>          <strong class="jxr_keyword">return</strong> doNotConsiderAnnotationsAsNodeStartForCodeAttribution;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>      }
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setDoNotConsiderAnnotationsAsNodeStartForCodeAttribution(
<a class="jxr_linenumber" name="L67" href="#L67">67</a>              <strong class="jxr_keyword">boolean</strong> doNotConsiderAnnotationsAsNodeStartForCodeAttribution) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>          <strong class="jxr_keyword">this</strong>.doNotConsiderAnnotationsAsNodeStartForCodeAttribution = doNotConsiderAnnotationsAsNodeStartForCodeAttribution;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>      }
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  
<a class="jxr_linenumber" name="L71" href="#L71">71</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> getDoNotAssignCommentsPreceedingEmptyLines() {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>          <strong class="jxr_keyword">return</strong> doNotAssignCommentsPreceedingEmptyLines;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>      }
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setDoNotAssignCommentsPreceedingEmptyLines(
<a class="jxr_linenumber" name="L76" href="#L76">76</a>              <strong class="jxr_keyword">boolean</strong> doNotAssignCommentsPreceedingEmptyLines) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>          <strong class="jxr_keyword">this</strong>.doNotAssignCommentsPreceedingEmptyLines = doNotAssignCommentsPreceedingEmptyLines;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>      }
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">     * Comments are attributed to the thing the comment and are removed from</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">     * allComments.</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> insertCommentsInCu(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/CompilationUnit.html">CompilationUnit</a> cu,
<a class="jxr_linenumber" name="L85" href="#L85">85</a>              <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/CommentsCollection.html">CommentsCollection</a> commentsCollection) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>          <strong class="jxr_keyword">if</strong> (commentsCollection.size() == 0)
<a class="jxr_linenumber" name="L87" href="#L87">87</a>              <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  
<a class="jxr_linenumber" name="L89" href="#L89">89</a>          <em class="jxr_comment">// I should sort all the direct children and the comments, if a comment</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>          <em class="jxr_comment">// is the first thing then it</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>          <em class="jxr_comment">// a comment to the CompilationUnit</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>          <em class="jxr_comment">// FIXME if there is no package it could be also a comment to the</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>          <em class="jxr_comment">// following class...</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>          <em class="jxr_comment">// so I could use some heuristics in these cases to distinguish the two</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>          <em class="jxr_comment">// cases</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  
<a class="jxr_linenumber" name="L97" href="#L97">97</a>          List&lt;Comment&gt; comments = commentsCollection.getAll();
<a class="jxr_linenumber" name="L98" href="#L98">98</a>          PositionUtils.sortByBeginPosition(comments);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>          List&lt;Node&gt; children = cu.getChildrenNodes();
<a class="jxr_linenumber" name="L100" href="#L100">100</a>         PositionUtils.sortByBeginPosition(children);
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a>         <strong class="jxr_keyword">if</strong> (cu.getPackage() != <strong class="jxr_keyword">null</strong>
<a class="jxr_linenumber" name="L103" href="#L103">103</a>                 &amp;&amp; (children.size() == 0 || PositionUtils.areInOrder(
<a class="jxr_linenumber" name="L104" href="#L104">104</a>                         comments.get(0), children.get(0)))) {
<a class="jxr_linenumber" name="L105" href="#L105">105</a>             cu.setComment(comments.get(0));
<a class="jxr_linenumber" name="L106" href="#L106">106</a>             comments.remove(0);
<a class="jxr_linenumber" name="L107" href="#L107">107</a>         }
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 
<a class="jxr_linenumber" name="L109" href="#L109">109</a>         insertCommentsInNode(cu, comments);
<a class="jxr_linenumber" name="L110" href="#L110">110</a>     }
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_javadoccomment">     * This method try to attributes the nodes received to child of the node. It</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">     * returns the node that were not attributed.</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> insertCommentsInNode(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/Node.html">Node</a> node,
<a class="jxr_linenumber" name="L117" href="#L117">117</a>             List&lt;Comment&gt; commentsToAttribute) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a>         <strong class="jxr_keyword">if</strong> (commentsToAttribute.size() == 0)
<a class="jxr_linenumber" name="L119" href="#L119">119</a>             <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a>         <em class="jxr_comment">// the comments can:</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a>         <em class="jxr_comment">// 1) Inside one of the child, then it is the child that have to</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a>         <em class="jxr_comment">// associate them</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a>         <em class="jxr_comment">// 2) If they are not inside a child they could be preceeding nothing, a</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a>         <em class="jxr_comment">// comment or a child</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a>         <em class="jxr_comment">// if they preceed a child they are assigned to it, otherweise they</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a>         <em class="jxr_comment">// remain "orphans"</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a>         List&lt;Node&gt; children = node.getChildrenNodes();
<a class="jxr_linenumber" name="L130" href="#L130">130</a>         PositionUtils.sortByBeginPosition(children);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 
<a class="jxr_linenumber" name="L132" href="#L132">132</a>         <strong class="jxr_keyword">for</strong> (Node child : children) {
<a class="jxr_linenumber" name="L133" href="#L133">133</a>             List&lt;Comment&gt; commentsInsideChild = <strong class="jxr_keyword">new</strong> LinkedList&lt;Comment&gt;();
<a class="jxr_linenumber" name="L134" href="#L134">134</a>             <strong class="jxr_keyword">for</strong> (Comment c : commentsToAttribute) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a>                 <strong class="jxr_keyword">if</strong> (PositionUtils.nodeContains(child, c,
<a class="jxr_linenumber" name="L136" href="#L136">136</a>                         doNotConsiderAnnotationsAsNodeStartForCodeAttribution)) {
<a class="jxr_linenumber" name="L137" href="#L137">137</a>                     commentsInsideChild.add(c);
<a class="jxr_linenumber" name="L138" href="#L138">138</a>                 }
<a class="jxr_linenumber" name="L139" href="#L139">139</a>             }
<a class="jxr_linenumber" name="L140" href="#L140">140</a>             commentsToAttribute.removeAll(commentsInsideChild);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>             insertCommentsInNode(child, commentsInsideChild);
<a class="jxr_linenumber" name="L142" href="#L142">142</a>         }
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a>         <em class="jxr_comment">// I can attribute in line comments to elements preceeding them, if</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a>         <em class="jxr_comment">// there</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a>         <em class="jxr_comment">// is something contained in their line</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a>         List&lt;Comment&gt; attributedComments = <strong class="jxr_keyword">new</strong> LinkedList&lt;Comment&gt;();
<a class="jxr_linenumber" name="L148" href="#L148">148</a>         <strong class="jxr_keyword">for</strong> (Comment comment : commentsToAttribute) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a>             <strong class="jxr_keyword">if</strong> (comment.isLineComment()) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a>                 <strong class="jxr_keyword">for</strong> (Node child : children) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a>                     <strong class="jxr_keyword">if</strong> (child.getEndLine() == comment.getBeginLine()) {
<a class="jxr_linenumber" name="L152" href="#L152">152</a>                         <strong class="jxr_keyword">if</strong> (attributeLineCommentToNodeOrChild(child,
<a class="jxr_linenumber" name="L153" href="#L153">153</a>                                 comment.asLineComment())) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a>                             attributedComments.add(comment);
<a class="jxr_linenumber" name="L155" href="#L155">155</a>                         }
<a class="jxr_linenumber" name="L156" href="#L156">156</a>                     }
<a class="jxr_linenumber" name="L157" href="#L157">157</a>                 }
<a class="jxr_linenumber" name="L158" href="#L158">158</a>             }
<a class="jxr_linenumber" name="L159" href="#L159">159</a>         }
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 
<a class="jxr_linenumber" name="L161" href="#L161">161</a>         <em class="jxr_comment">// at this point I create an ordered list of all remaining comments and</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a>         <em class="jxr_comment">// children</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a>         <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/Comment.html">Comment</a> previousComment = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L164" href="#L164">164</a>         attributedComments = <strong class="jxr_keyword">new</strong> LinkedList&lt;Comment&gt;();
<a class="jxr_linenumber" name="L165" href="#L165">165</a>         List&lt;Node&gt; childrenAndComments = <strong class="jxr_keyword">new</strong> LinkedList&lt;Node&gt;();
<a class="jxr_linenumber" name="L166" href="#L166">166</a>         childrenAndComments.addAll(children);
<a class="jxr_linenumber" name="L167" href="#L167">167</a>         childrenAndComments.addAll(commentsToAttribute);
<a class="jxr_linenumber" name="L168" href="#L168">168</a>         PositionUtils.sortByBeginPosition(childrenAndComments,
<a class="jxr_linenumber" name="L169" href="#L169">169</a>                 doNotConsiderAnnotationsAsNodeStartForCodeAttribution);
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a>         <strong class="jxr_keyword">for</strong> (Node thing : childrenAndComments) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a>             <strong class="jxr_keyword">if</strong> (thing instanceof Comment) {
<a class="jxr_linenumber" name="L173" href="#L173">173</a>                 previousComment = (Comment) thing;
<a class="jxr_linenumber" name="L174" href="#L174">174</a>                 <strong class="jxr_keyword">if</strong> (!previousComment.isOrphan()) {
<a class="jxr_linenumber" name="L175" href="#L175">175</a>                     previousComment = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L176" href="#L176">176</a>                 }
<a class="jxr_linenumber" name="L177" href="#L177">177</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L178" href="#L178">178</a>                 <strong class="jxr_keyword">if</strong> (previousComment != <strong class="jxr_keyword">null</strong> &amp;&amp; !thing.hasComment()) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a>                     <strong class="jxr_keyword">if</strong> (!doNotAssignCommentsPreceedingEmptyLines
<a class="jxr_linenumber" name="L180" href="#L180">180</a>                             || !thereAreLinesBetween(previousComment, thing)) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a>                         thing.setComment(previousComment);
<a class="jxr_linenumber" name="L182" href="#L182">182</a>                         attributedComments.add(previousComment);
<a class="jxr_linenumber" name="L183" href="#L183">183</a>                         previousComment = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L184" href="#L184">184</a>                     }
<a class="jxr_linenumber" name="L185" href="#L185">185</a>                 }
<a class="jxr_linenumber" name="L186" href="#L186">186</a>             }
<a class="jxr_linenumber" name="L187" href="#L187">187</a>         }
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 
<a class="jxr_linenumber" name="L189" href="#L189">189</a>         commentsToAttribute.removeAll(attributedComments);
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 
<a class="jxr_linenumber" name="L191" href="#L191">191</a>         <em class="jxr_comment">// all the remaining are orphan nodes</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a>         <strong class="jxr_keyword">for</strong> (Comment c : commentsToAttribute) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a>             <strong class="jxr_keyword">if</strong> (c.isOrphan()) {
<a class="jxr_linenumber" name="L194" href="#L194">194</a>                 node.addOrphanComment(c);
<a class="jxr_linenumber" name="L195" href="#L195">195</a>             }
<a class="jxr_linenumber" name="L196" href="#L196">196</a>         }
<a class="jxr_linenumber" name="L197" href="#L197">197</a>     }
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 
<a class="jxr_linenumber" name="L199" href="#L199">199</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> attributeLineCommentToNodeOrChild(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/Node.html">Node</a> node,
<a class="jxr_linenumber" name="L200" href="#L200">200</a>             <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/comments/LineComment.html">LineComment</a> lineComment) {
<a class="jxr_linenumber" name="L201" href="#L201">201</a>         <em class="jxr_comment">// The node start and end at the same line as the comment,</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a>         <em class="jxr_comment">// let's give to it the comment</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a>         <strong class="jxr_keyword">if</strong> (node.getBeginLine() == lineComment.getBeginLine()
<a class="jxr_linenumber" name="L204" href="#L204">204</a>                 &amp;&amp; !node.hasComment()) {
<a class="jxr_linenumber" name="L205" href="#L205">205</a>             node.setComment(lineComment);
<a class="jxr_linenumber" name="L206" href="#L206">206</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L207" href="#L207">207</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L208" href="#L208">208</a>             <em class="jxr_comment">// try with all the children, sorted by reverse position (so the</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a>             <em class="jxr_comment">// first one is the nearest to the comment</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a>             List&lt;Node&gt; children = <strong class="jxr_keyword">new</strong> LinkedList&lt;Node&gt;();
<a class="jxr_linenumber" name="L211" href="#L211">211</a>             children.addAll(node.getChildrenNodes());
<a class="jxr_linenumber" name="L212" href="#L212">212</a>             PositionUtils.sortByBeginPosition(children);
<a class="jxr_linenumber" name="L213" href="#L213">213</a>             Collections.reverse(children);
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 
<a class="jxr_linenumber" name="L215" href="#L215">215</a>             <strong class="jxr_keyword">for</strong> (Node child : children) {
<a class="jxr_linenumber" name="L216" href="#L216">216</a>                 <strong class="jxr_keyword">if</strong> (attributeLineCommentToNodeOrChild(child, lineComment)) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a>                     <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L218" href="#L218">218</a>                 }
<a class="jxr_linenumber" name="L219" href="#L219">219</a>             }
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 
<a class="jxr_linenumber" name="L221" href="#L221">221</a>             <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L222" href="#L222">222</a>         }
<a class="jxr_linenumber" name="L223" href="#L223">223</a>     }
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 
<a class="jxr_linenumber" name="L225" href="#L225">225</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> thereAreLinesBetween(<a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/Node.html">Node</a> a, <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/javaparser/ast/Node.html">Node</a> b) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a>         <strong class="jxr_keyword">if</strong> (!PositionUtils.areInOrder(a, b)) {
<a class="jxr_linenumber" name="L227" href="#L227">227</a>             <strong class="jxr_keyword">return</strong> thereAreLinesBetween(b, a);
<a class="jxr_linenumber" name="L228" href="#L228">228</a>         }
<a class="jxr_linenumber" name="L229" href="#L229">229</a>         <strong class="jxr_keyword">int</strong> endOfA = a.getEndLine();
<a class="jxr_linenumber" name="L230" href="#L230">230</a>         <strong class="jxr_keyword">return</strong> b.getBeginLine() &gt; (endOfA + 1);
<a class="jxr_linenumber" name="L231" href="#L231">231</a>     }
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 
<a class="jxr_linenumber" name="L233" href="#L233">233</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
